.include "cpctelera.h.s"
.include "includes.s"
.include "man/game_manager.h.s"
.include "man/menu.h.s"
.include "man/credits.h.s"
.include "man/game_over.h.s"

.area _DATA
.area _CODE

.globl cpct_setPALColour_asm

uncontador: .db 06
int_handler::
   push af
   push bc
   push de
   push hl

   ld a, (uncontador)
   dec a
   jr nz, _cont
_zero:
   call cpct_akp_musicPlay_asm
   ld a, #6
_cont:
   ld (uncontador), a
   
   pop hl
   pop de
   pop bc
   pop af
   ei
   reti


set_int_hanlder:
   di
   ld hl, #0x38
   ld (hl), #0xC3
   inc hl
   ld (hl), #<int_handler
   inc hl
   ld (hl), #>int_handler
   inc hl
   ld (hl), #0xC9
   ei
   ret


;;
.globl cpct_disableFirmware_asm

_main::

   ld sp, #0x7FFF
   ;; Disable firmware to prevent it from interfering with string drawing
   ;; call cpct_disableFirmware_asm
   
   ;; ======== MUSICA -> DE MOMENTO NO FUNCIONA ========
   call set_int_hanlder
   ld de, #_Music_01
   call cpct_akp_musicInit_asm
   ; El play esta en el menu.s
   ;; ======== MUSICA -> DE MOMENTO NO FUNCIONA ========

   bucle_menu:
   call menu_init
   call menu_update
   call main_new_bucle

   bucle_juego:
   call manager_game_init
   call manager_game_update
   call main_new_bucle

   bucle_creditos:
   call credits_init
   call credits_update
   call main_new_bucle

   bucle_game_over:
   call game_over_init
   call game_over_update
   call main_new_bucle

main_new_bucle:
   cp #LOOP_MENU
   jr z, bucle_menu
   
   cp #LOOP_GAME
   jr z, bucle_juego

   cp #LOOP_CREDITS
   jr z, bucle_creditos

   cp #LOOP_GAME_OVER
   jr z, bucle_game_over

   ret