.include "cpctelera.h.s"
.include "game_manager.h.s"
.include "manager_entity.h.s"
.include "sys/sys_physics.h.s"
.include "sys/render.h.s"
.include "sys/animations.h.s"
.include "sys/input.h.s"
.include "man/level.h.s"
.include "sys/camera.h.s"
.include "man/entity_colision.h.s"
.include "sys/colision.h.s"
.include "sys/ia_control.h.s"
.include "templates.h.s"
.include "man/sfx.h.s"

puntuacion:: .dw 0x0000

.globl cpct_waitVSYNC_asm



;;;; Inicializar
manager_game_init::
    call man_level_init
    call entity_man_init

    call sys_render_init
    call sys_ia_control_init
    call man_entity_colision_init
    call sys_colision_init
    call sys_input_init
    call sys_physics_init
    call man_sfx_init
    ;; crear jugador
    ld hl, #entity_player_temp
    call entity_man_create

    ;ld hl, #entity_door
    ;call entity_man_create
    ld hl, #entity_door
    call entity_man_create
    call create_enemys_for_level

;;
;;;; Bucle del juego
;;;; Bucle del juego
manager_game_update::
    call cpct_waitVSYNC_asm
    call sys_render_update
    call sys_input_update
    call entity_man_update

    call colision_update
    call sys_ia_control_update
    call sys_physics_update
    call sys_animations_update
    call sys_camera_update
    call man_sfx_update
    call entity_man_update

    ld a, (color_fondo)
    or a
    jr z, check_if_game_over
    jr manager_game_update
    
    fin_del_juego:
    push af
    call change_screen_to_C000
    pop af
    ret
;;
;;
;;
;;


;; COMPRUEBA SI SE HA REALIZADO UN GAME_OVER
check_if_game_over::
    ;; "IX" = Direccion del jugador
    ld ix, #entities
    ;; "A" = Vidas del jugador
    ld a, e_vidas(ix)
    or a
    jr nz, vidas_not_zero
    ;; IF @( VIDAS == 0 )
    ;; {
        ld a, #3
        jr fin_del_juego
    ;; }

    vidas_not_zero:
    ld hl, #Key_Esc
    call cpct_isKeyPressed_asm
    jr z, manager_game_update
    ;; IF @ ( TECLA_ESC IS PRESSED )
    ;; {
        ld a, #0
        jr fin_del_juego
    ;; }

    ret



;; ENTRADA
;;  "BC" = Puntos que se anyaden al score del juego
add_bc_to_score::
    ;; "HL" = Puntuacion total actual 
    ld hl, (puntuacion)
    ;; "A" = Ultimos 2 digitos de la puntuacion
    ld a, l
    ;; Le sumo a "A" los ultimos digitos del score a sumar
    add c
    ;; Y lo normalizo a sistema decimal
    daa

    ;; Guardo en "L" el valor despues de la suma y hago lo mismo con "H" para los siguientes 2 digitos
    ld l, a
    ld a, h
    ;; Le sumo a "A" los primeros digitos del score a sumar
    adc b
    ;; Y lo normalizo a sistema decimal
    daa

    jr nc, todavia_no_es_puntos_maximos
    ;; IF @( PUNTUACION + BC > 9999 )
    ;; {
        ;; Guardo el valor para recuperarlo al final
        push af
        ;; "A" = Las vidas que se han conseguido en total en todo el juego
        ld a, (vidas_extra_totales)
        ;; Se incrementa una vida de las totales
        ld b, #1
        add a, b
        daa
        ;; Y se guarda en la variable
        ld (vidas_extra_totales), a

        ;; "IX" = Direccion del jugador
        ld ix, #entities
        ;; "A" = Las vidas rojas del jugador
        ld a, e_vidas(ix)
        ;; "IY" = Direccion de las vidas amarillas actuales
        ld iy, #vidas_extra_actuales
        ;; "B" = Valor de las vidas amarillas (0, 1, 2...)
        ld b, (iy)
        ;; "A" = "A" + "B"
        add a, b
        ;; Si la suma de corazones totales es 5, no sumo una mas
        cp #5
        jr z, no_sumar_vida_extra
            ld a, (vidas_extra_actuales)
            inc a
            ld (vidas_extra_actuales), a

            push hl
            ld hl, #_sfx_heal
            ld b, e_sx(ix)
            ld c, #70
            call man_sfx_create
            pop hl
            ld hl, #cont
            ld a, (hl)
            inc a
            ld (hl), a

        no_sumar_vida_extra:
        pop af
    ;; }

    ;; ELSE
    ;; {
        todavia_no_es_puntos_maximos:
        ld h, a
        ld (puntuacion), hl
        call sys_render_UI_both
    ;; }
    ret


create_enemys_for_level::
    cp #0
    jr z, _level0

    cp #1
    jr z, _level1

    cp #2
    jp z, _level2

    _level0:

        ld hl,(cont)
        ld de,#4
        add hl, de
        ex de, hl
        ld__iyl_e                   

        ld b, #90 

        _lp0:
            push bc
            ld hl, #entity_player_temp2
            call entity_man_create
            ld b, e_vidas(ix)
            ld a, (man_level_round)
            add b
            ld e_vidas(ix), a
            pop bc
            ld a, b
            add #25
            ld e_x(ix), a
            sub #25
            add #32
            ld b, a

            dec__iyl
            jr nz, _lp0

        
        ret

    _level1:
        ld hl,(cont)
        ld de,#4
        add hl, de
        ex de, hl
        ld__iyl_e      
        ld b, #90 
        
        _lp1:
            push bc
            ld hl, #entity_player_temp2
            call entity_man_create
            ld b, e_vidas(ix)
            ld a, (man_level_round)
            add b
            ld e_vidas(ix), a
            pop bc
            ld a, b
            add #20
            ld e_x(ix), a
            sub #20
            add #32
            ld b, a

    

            dec__iyl
            jr nz, _lp1

        ld hl,(cont)
        ld de,#2
        add hl, de
        ex de, hl
        ld__iyl_e
        ld b, #100 

        _lp1esqueleto:
            push bc
            ld hl, #entity_esqueleto
            call entity_man_create
            pop bc
            ld a, b
            add #20
            ld e_x(ix), a
            sub #20
            add #40
            ld b, a
            dec__iyl
            jr nz, _lp1esqueleto
  
        ret

    _level2:
        ld hl, #entity_cofre
        call entity_man_create
        ld hl,(cont)
        ld de,#5
        add hl, de
        ex de, hl
        ld__iyl_e
        ld b, #90 
        _lp2:
            push bc
            ld hl, #entity_player_temp2
            call entity_man_create
            ld b, e_vidas(ix)
            ld a, (man_level_round)
            add b
            ld e_vidas(ix), a
            pop bc
            ld a, b
            add #5
            ld e_x(ix), a
            sub #5
            add #50
            ld b, a

            dec__iyl
            jr nz, _lp2

        ld hl,(cont)
        ld de,#2
        add hl, de
        ex de, hl
        ld__iyl_e
        ld b, #100 
        _lp2esqueleto:
            push bc
            ld hl, #entity_esqueleto
            call entity_man_create
            pop bc
            ld a, b
            add #25
            ld e_x(ix), a
            sub #25
            add #40
            ld b, a
            dec__iyl
            jr nz, _lp2esqueleto
            ld hl, #enemy_move_cdown
            ld a, (hl)
            cp #1
            ret z
            dec a
            ld (hl), a
            ld hl, #enemy_ataque_cdown
            ld a, (hl)
            sub #20
            ld (hl), a
            

        ret

    
        
    ret