.module Game_Over_Manager

.include "cpctelera.h.s"
.include "includes.s"
.include "man/manager_entity.h.s"
.globl puntuacion
.globl dibujar_nombres
.include "sprites/menu.h.s"
.include "sys/render.h.s"


string_game_over: .asciz "GAME OVER"
string_final_score: .asciz "SCORE:"



;; =================== INIT DE MENU INICIAL =================== ;
;; MAS DETALLES
;;  Borra la pantalla y escribe nuestros nombres
;; ============================================================ ;
game_over_init::
    call sys_render_init
    ;; Inicializa el render para tener el borde, el modo de video y la paleta actualizada
    ;; Direccion final a la que se va a copiar la imagen de fondo
    ld de, #0xFFFF
    ;; Direccion final de la imagen de fondo comprimida
    ld hl, #_menu_end
    ;; Llamada al descompresor
    call cpct_zx7b_decrunch_s_asm

    ld hl, #0x0006
    call cpct_setDrawCharM0_asm

    ld de, #0xC000
    ld bc, #0xC500                ;; Posicion del primer rectangulo
    call cpct_getScreenPtr_asm    ;; "HL" = Puntero en la pantalla
    ex de, hl
    ld a, #0                     ;; Fondo color negro
    ld c, #50                     ;; Ancho = 40
    ld b, #62                     ;; Alto  = 40
    call cpct_drawSolidBox_asm    ;; Dibujar rectangulo


    ld de, #0xC000
    ld bc, #0x9638                ;; Posicion del primer rectangulo
    call cpct_getScreenPtr_asm    ;; "HL" = Puntero en la pantalla
    ex de, hl
    ld a, #0                     ;; Fondo color negro
    ld c, #24                     ;; Ancho = 40
    ld b, #50                     ;; Alto  = 40
    call cpct_drawSolidBox_asm    ;; Dibujar rectangulo



    ;ld iy, #string_game_over
    ;ld b, #40
    ;call dibujar_nombres
    ld iy, #string_game_over
    ld de, #CPCT_VMEM_START_ASM
    ld c, #42
    ld b, #35
    call cpct_getScreenPtr_asm
    call cpct_drawStringM0_asm


    ;; STRING DE "SCORE:"
    ld iy, #string_final_score
    ld de, #CPCT_VMEM_START_ASM
    ld c, #45
    ld b, #67
    call cpct_getScreenPtr_asm
    call cpct_drawStringM0_asm



    ;; SPRITE DE ESC
    ld de, #0xC000
    ld bc, #0xB839
    call cpct_getScreenPtr_asm
    ex de, hl
    ld hl, #_SP_Esc
    ld bc, #0x0D16
    call cpct_drawSprite_asm


    ;; PUNTUACION
    ld de, #0xC000
    ld bc, #0x522D
    call cpct_getScreenPtr_asm

    ld a, (vidas_extra_totales)
    call game_over_draw_score

    ld bc, (puntuacion)
    ld a, b
    call game_over_draw_score
    ld bc, (puntuacion)
    ld a, c
    call game_over_draw_score


    ret
;; ============================================================ ;



;; ====================== UPDATE DEL MENU ===================== ;
;; MAS DETALLES
;;  Escanea el teclado, cambia el focus
;; SALIDA
;;  "A" con el indice de la opcion cuando se pulse ENTER
;; ============================================================ ;
game_over_update::
    call cpct_waitVSYNC_asm
    call cpct_scanKeyboard_f_asm

    ld hl, #Key_Esc
    call cpct_isKeyPressed_asm
    jr z, game_over_update
    ld a, #0
    ret
;; ============================================================ ;


game_over_draw_score::
    push af
    rra
    rra
    rra
    rra
    and #0x0F
    add #48
    ld e, a
    push hl
    call cpct_drawCharM0_asm
    pop hl
    ld bc, #04
    add hl, bc
    pop af
    and #0x0F
    add #48
    ld e, a
    push hl
    call cpct_drawCharM0_asm
    pop hl
    ld bc, #04
    add hl, bc
    ret