.include "level.h.s"
.include "man/manager_entity.h.s"
.include "sys/render.h.s"
.include "cpctelera.h.s"
.include "includes.s"
.include "man/game_manager.h.s"

;; ESPACIO RESERVADO PARA EL MAPA
man_level_map:: .ds man_level_map_size
man_level_map_end = .-1

man_level_map_camera::
    .dw man_level_map       ;; Puntero al tilemap al que apunta la camara
    .db 0, 0                ;; Camera (x, y) -> World coordinates
    .db 0, 0                ;; Follow (x, y) -> Screen coordinates
    .db 0                   ;; Camera state  -> Cuantos tiles me he de mover
man_level_map_camera_size = . - man_level_map_camera

man_level_num_tilemap:: .db 0
man_level_round:: .db 0
man_level_tilemap_has_change:: .db 0

.globl _tilemap_00_end
.globl _tilemap_01_end
.globl _tilemap_02_end


man_level_init::
    ;; Inicializar camara
    xor a
    ld (man_level_num_tilemap), a
    ld (man_level_round), a

    call man_level_change

    ld hl, #man_level_map_camera
    ld de, #man_level_map_camera + 1
    ld bc, #man_level_map_camera_size - 1
    ld (hl), #0
    ldir

    xor a
    ld (puntuacion), a
    ld (puntuacion+1), a
    ld (color_fondo), a

    ld hl, #man_level_map
    ld (man_level_map_camera), hl
    ret


man_level_inc_num_tilemap::
    ld a, (man_level_num_tilemap)
    inc a
    cp #3
    jr nz, num_tilemap_valido
        xor a
    num_tilemap_valido:
    ld (man_level_num_tilemap), a
    ld a, (man_level_round)
    inc a
    ld (man_level_round), a

    call man_level_change
    ld a, (man_level_num_tilemap)
    call create_enemys_for_level
    ret


;; RECIBE A CON EL NIVEL
man_level_change:
    
    ld ix, #entities
    ld e_x(ix), #10
    ld e_sx(ix), #10
    xor a
    ld (man_level_map_camera + cam_x), a
    ld (man_level_map_camera + cam_follow_x), a
    ld (man_level_map_camera + cam_state), a

    ld a, #2
    ld (extra_tile_loop), a

    ld a, (man_level_num_tilemap)
    ;; IF @( NUM_TILEMAP == 2 )
    ;; {
        cp #NUM_TILEMAP_2
        call z, man_level_change_2
    ;; }

    ;; ELSE IF @( NUM_TILEMAP == 1 )
    ;; {
        cp #NUM_TILEMAP_1
        call z, man_level_change_1
    ;; }

    ;; ELSE IF @( NUM_TILEMAP == 0 )
    ;; {
        cp #NUM_TILEMAP_0
        call z, man_level_change_0
    ;; }

    ld hl, #man_level_map
    ld (man_level_map_camera), hl

    ret


man_level_change_0:
    push af
    ld de, #man_level_map_end
    ld hl, #_tilemap_00_end
    call cpct_zx7b_decrunch_s_asm
    ld a, #1
    ld (man_level_tilemap_has_change), a
    pop af
    ret


man_level_change_1:
    push af
    ld de, #man_level_map_end
    ld hl, #_tilemap_01_end
    call cpct_zx7b_decrunch_s_asm
    ld a, #1
    ld (man_level_tilemap_has_change), a
    pop af
    ret


man_level_change_2:
    push af
    ld de, #man_level_map_end
    ld hl, #_tilemap_02_end
    call cpct_zx7b_decrunch_s_asm
    ld a, #1
    ld (man_level_tilemap_has_change), a
    pop af
    ret