.include "manager_entity.h.s"
.include "man/entity_colision.h.s"
.include "sys/render.h.s"
.include "sys/colision.h.s"
.include "cpctelera.h.s" 
;;;;;;
.globl cpct_memset_asm
;;
;;;; Reserva de memoria
    entities:: 
        .ds ENTITY_MAX*ENTITY_SIZE      ;;Detras del array de bytes tendremos un byte a 0 para determinar que no hay mas entitdades
        .db 0x00
    next_entities::
        .ds 2
 ;;   entity_template::
 ;;       .db TYPE_DEFAULT                ;; Tipo
 ;;       .db COMP_DEFAULT                ;; Componente
 ;;       .db 0                           ;; Posicion en x
 ;;       .db 0                           ;; Posicion en y
 ;;       .db 0                           ;; Velocidad en x
 ;;       .db 0                           ;; Velocidad en y
 ;;       .db 0                           ;; Ancho del sprite
 ;;       .db 0                           ;; Alto del sprite
 ;;       .dw 0                           ;; Sprite
 ;;       .dw 0                           ;; animacion 
 ;;       .db 0                           ;; Contador de animacion
 ;;       .dw 0xCCCC         ;;ultima dirección de memoria en la que ha estado la entidad para optimizar el borrado en el render, por defecto pondremos 0xCCCC
 ;;       .dw 0xCCCC         ;;ultima dirección de memoria en la que ha estado la entidad para optimizar el borrado en el render, por defecto pondremos 0xCCCC
 ;;       .db 0               ;;Ataque
 ;;       .db 0                           ;; sprite
 ;;       .db 0                           ;; sprite
 ;;       .db 0                           ;; SF x
 ;;       .db 0                           ;; SF y
 ;;       .db 0                           ;; Vida
 ;;       .db 0                           ;; Impulso
 ;;       .db 0                           ;; IA_X
 ;;       .db 0                           ;; IA_Estado
 ;;       .db 0                           ;; Cooldown para los ticks al moverse

    num_entities::
        .ds 1
    sprite_combo::
        .dw _SP_Player1_3

    vidas_extra_actuales:: .db 0
    vidas_extra_totales:: .db 0

;; ==================== INIT DE MAN ENTITY ==================== ;
 entity_man_init::
    ld de, #entities
    xor a
    ld bc, #ENTITY_SIZE*ENTITY_MAX
    call cpct_memset_asm                ;; Reserva los bytes que ocuparan las entidades

    ld de, #entities
    ld (next_entities), de              ;; Hace que apunte a la primera entidad

    xor a
    ld (num_entities), a                 ;; Resetea el numero de entidades a 0
    ld (vidas_extra_actuales), a
    ld (vidas_extra_totales), a
    ret 

;; ============================================================ ;



;; =================== CREAR NUEVA ENTIDAD ==================== ;
;; PARAMETROS NECESARIOS
;;  HL = Direccion de memoria donde leer la plantilla de entidad
;; SALIDA 
;;  IX = Direccion de la entidad creada
;; ============================================================ ;
 entity_man_create::

    ld      de, (next_entities)
    ld      bc, #ENTITY_SIZE
    ldir                            ;; Instruccion que copia el contenido que apunta HL a la direccion que apunta DE, al copiarlo incrementa en 1 cada valor para apuntar al siguiente y esto lo hara las veces que indique BC

    ld      ix, (next_entities)      ;; guardamos en IX la direccion de la nueva entidad

    ld      bc, #ENTITY_SIZE
    ld      hl, (next_entities)
    add     hl, bc
    ld      (next_entities), hl     ;; actualizamos el puntero q apunta a la siguiente entidad

    ld      a, (num_entities)
    inc     a
    ld      (num_entities), a       ;; aumentamos el numero de entidades

    ld      a, e_comp(ix)
    and #COMP_COLISION
    call nz, man_entity_colision_add
     
    ld      a, e_type(ix)
    and     #TYPE_BALA

    ret z

    pop de

    pop iy

    ld  a, e_x(iy)
    ld e_x(ix), a
    ld  a, e_y(iy)
    add #10
    ld e_y(ix), a
    push iy
    push de

    ret

;; ============================================================ ;



;; ===================== COMPROBAR ESPACIO ==================== ;
;; MAS DETALLES
;;  Comprobamos si tenemos espacio para crear entidades
;; SALIDA 
;;  Si no hay espacio el flag Z valdra 1 y 0 si si hay espacio    
;; ============================================================ ;
 entity_man_free_space::
    ld c, #ENTITY_MAX
    ld a, (num_entities)
    cp c
    ret

;; ============================================================ ;



;; ===================== FORALL ENTIDADES ===================== ;
;; MAS DETALLES
;;  Tiene como funcion ejecutar cierta funcion de todas las entidades
;; ENTRADA 
;;  HL = Direccion de memoria de la funcion a ejecutar  
;; ============================================================ ;
 entity_man_forall::
    ld ix, #entities        ;; IX la usaremos para recorrer todas las entidades
    ld  (man_call), hl

    recorrer_array:
    ld a, (ix)              ;; Comprobamos que la entidad no es de tipo invalid
    or a
    jr z, man_end
    ;; IF @( ENTITY_TYPE != INVALID )
    ;; {
        push ix             ;; Guardamos la direccion de la entidad

        man_call = .+1
        call man_call
        
        pop ix              ;; Recupero la direccion de la entidad

        ld  bc, #ENTITY_SIZE
        add ix, bc
        jr recorrer_array
    ;; }

    man_end:
    ret

;; ============================================================ ;



;; ================ FORALL MATCHING ENTIDADES ================= ;
;; MAS DETALLES
;;  Tiene como funcion ejecutar cierta funcion de todas las entidades siempre y cuando tengan los componentes necesarios
;; ENTRADA 
;;  HL = Direccion de memoria de la funcion a ejecutar
;;  B  = Contiene los componentes
;; ============================================================ ;
 entity_man_forall_matching::
    ld  (man_maching_call), hl
    ld ix, #entities        ;; IX la usaremos para recorrer todas las entidades

    recorrer_array_maching:
    ld a, (ix)              ;; Comprobamos que la entidad no es de tipo invalid
    or  a
    jr  z,   man_end_maching
        push bc
        ld a, e_comp(ix)
        and b
        sub b
        jp nz, not_match

        push ix             ;; Guardamos la direccion de la entidad

        man_maching_call = .+1
            call man_maching_call
        
        pop ix              ;; Recupero la direccion de la entidad

        not_match:
        ld  bc, #ENTITY_SIZE
        add ix, bc

        pop bc
            
        jr recorrer_array_maching

    man_end_maching:
    ret

;; ============================================================ ;



;; ================== FOR JUST ENTITY PLAYER ================== ;
;; MAS DETALLES
;;  Llama a la funcion por parametro pero solo para el jugador
;; ENTRADA 
;;  HL = Direccion de memoria de la funcion a ejecutar
;; ============================================================ ;
entity_man_forjust_player::
    ld  (man_justplayer_call), hl
    ld ix, #entities        ;; IX la usaremos para recorrer todas las entidades
    man_justplayer_call = .+1
    call man_justplayer_call
    ret

;; ============================================================ ;



;; ================== FOR NOT ENTITY PLAYER =================== ;
;; MAS DETALLES
;;  Llama a la funcion por parametro para todas las entidades excepto para el jugador
;; ENTRADA 
;;  HL = Direccion de memoria de la funcion a ejecutar
;; ============================================================ ;
entity_man_forall_but_player::
    ld ix, #entities + #ENTITY_SIZE        ;; IX la usaremos para recorrer todas las entidades
    ld  (man_maching_call), hl
    jr recorrer_array_maching
    ret

;; ============================================================ ;




;; ===================================================== ;;
;; INPUT IX -> PRIMER BYTE DE LAS ENTIDADES              ;;
;; DESTRUYE LA ENTIDAD QUE SE LE PASA POR PARAMETRO      ;;
;; ===================================================== ;;

entity_man_destroy::

    ;; Registro "BC" = Ultima ENTIDAD creada
    ;;ld bc, #next_entities - #ENTITY_SIZE
    ld hl, #-ENTITY_SIZE
    ld bc, (next_entities)
    add hl, bc
    ;; Guardo "BC" en la pila para el final del metodo
    push hl

    push ix
    pop hl

    ;; AQUI COMPRUEBO SI LAS DIRECCIONES SON IGUALES
    ld a, b
    cp h
    jr nz, NO_ultima_entidad_destruir

       ld a, c
       cp l
       jr z, if_ultima_entidad_destruir
          NO_ultima_entidad_destruir:
          push ix
          push ix
          pop de
          ld hl, #-ENTITY_SIZE
          ld bc, (next_entities)
          add hl, bc
          push hl
          ld bc, #ENTITY_SIZE               ;; TAMANYO DE LA ENTIDAD
          call cpct_memcpy_asm          ;; PEGA "HL" EN "DE" CON TAMANYO "BC"
          pop ix
     
          pop iy
       if_ultima_entidad_destruir:
          ld e_type(ix), #TYPE_INVALID
          call man_entity_colision_erase

    ;; Rescato el registro "BC" que habia metido en la pila anteriormente
    pop bc
    ;; Actualizo next_entities
    ld (next_entities), bc

    ret
;; ===================================================== ;;



;; ===================================================== ;;
;; INPUT IX -> PRIMER BYTE DE LA ENTIDAD A MARCAR        ;;
;; Pone el tipo de la entidad "IX" a "TYPE_TUMBA"        ;;
;; ===================================================== ;;
entity_man_set4destruction::
   ld a, (ix)
   or #TYPE_TUMBA
   ld e_type(ix), a
   ret
;; ===================================================== ;;




entity_man_update::
    ld ix, #entities

    ld a, e_cooldown_vida(ix)
    or #0
    jr z, vida_overflow
    ;; IF @( JUGADOR TIENE COOLDOWN DE VIDA )
    ;; {
        dec a
        ld e_cooldown_vida(ix), a
        ld (color_fondo), a
    ;; }

    vida_overflow:
    ld a, e_vidas(ix)
    cp #0xFF
    jr c, entity_valida_bucle_2
    ;; IF @( VIDAS_JUGADOR < 0 )
    ;; {
        xor a
        ld e_vidas(ix), a
    ;; }

    entity_valida_bucle_2:
        ld a, e_type(ix)
        or #TYPE_INVALID
        jr z, if_entity_invalida_2

        and #TYPE_TUMBA
        jr z, if_entiy_invalida_3
        ;;ld ix, #entities
        call entity_man_destroy
        jr if_entity_invalida_4
        if_entiy_invalida_3:
            ld de, #ENTITY_SIZE
            add ix, de
            if_entity_invalida_4:
            jr entity_valida_bucle_2
        if_entity_invalida_2:
        
   ret