.include "cpctelera.h.s"
.include "sfx.h.s"
.include "animation.h.s"
.include "sys/render.h.s"

memoria_sfx: .ds 66
next_free_sfx: .dw memoria_sfx
num_sfx:: .ds 1

man_sfx_init::
   ld hl, #memoria_sfx           ;; HL = SITIO DE MEM. DONDE ESTA LA 1º ENTIDAD DE MEMORIA_ENTIDADES
   ld (next_free_sfx), hl
   xor a
   ld (num_sfx), a

   ex de, hl
   ld a, #0
   ld bc, #66
   call cpct_memset_asm   
   ret


;; ==================== CREAR UN EFECTO SFX =================== ;
;; MAS DETALLES
;;  Borra la antigua posicion y dibuja la entidad en su (x,y)
;; ENTRADA
;;  HL = Plantilla del SFX que crear
;;  B  = Posicion en X donde spawnear el SFX
;;  C  = Posicion en Y donde spawnear el SFX
;; ============================================================ ;
man_sfx_create::
   
   ld a, (num_sfx)
   cp #4
   ret z
   
   push bc
   ld bc, #sfx_size               ;; TAMANYO DE LA ENTIDAD
   ld de, (next_free_sfx)
   call cpct_memcpy_asm          ;; PEGA "HL" EN "DE" CON TAMANYO "BC"
   
   ld a, (num_sfx)
   inc a
   ld (num_sfx), a
   
   ;; +1 AL NUMERO DE ENTIDADES CREADAS
   ld bc, (next_free_sfx)           ;; BC = EL SIGUIENTE HUECO PARA METER UNA ENTIDAD
   ld hl, #sfx_size                 ;; HL = TAMANYO DE UNA ENTIDAD (5)
   add hl, bc                       ;; LOS SUMO, DEJO EL HUECO DE ESTA ENTIDAD
   ld (next_free_sfx), hl           ;; Y AHORA LA PROXIMA ES 5 POS MAS ADELANTE
   
   ld h, b
   ld l, c

   pop bc
   ld de, #SFX_X
   add hl, de
   ld (hl), b
   inc hl
   ld (hl), c

   ret


man_sfx_forall::
   ld ix, #memoria_sfx
   ld  (sfx_call), hl

   sfx_valida_bucle:
   ld a, SFX_TYPE(ix)
   or #0
   jr z, if_sfx_invalida
   ;; IF @( ENTITY_TYPE != INVALID )
   ;; {
      push ix             ;; Guardamos la direccion de la entidad
      sfx_call = .+1
      call sfx_call
      pop ix              ;; Recupero la direccion de la entidad
      ld  bc, #sfx_size
      add ix, bc
      jr sfx_valida_bucle
   ;; }
   if_sfx_invalida:
   ret


;; ===================================================== ;;
;; INPUT IX -> PRIMER BYTE DEL *SFX*                     ;;
;; DESTRUYE EL SFX QUE SE LE PASA POR PARAMETRO          ;;
man_sfx_destroy::

   ;; Intercambio "IX" por "HL"
   ld hl, #-sfx_size
   ld bc, (next_free_sfx)
   add hl, bc
   ;; Guardo "BC" en la pila para el final del metodo
   push hl

   ;; AQUI COMPRUEBO SI LAS DIRECCIONES SON IGUALES
   push ix
   pop hl

   ld a, b
   cp h
   jr nz, NO_ultimo_sfx_destruir
   ;; IF @( H == B )
   ;; {
      ld a, c
      cp l
      jr z, if_ultima_sfx_destruir

      ;; IF @( SFX_PARAMETRO != ULTIMO_SFX )
      ;; {
         NO_ultimo_sfx_destruir:
         push ix
         pop de
         ld hl, #-sfx_size
         ld bc, (next_free_sfx)
         add hl, bc
         push hl
         ld bc, #sfx_size
         call cpct_memcpy_asm
         pop ix
      ;; }
   
      if_ultima_sfx_destruir:
      ;; ELSE IF @( SFX_PARAMETRO == ULTIMO_SFX )
      ;; {
         ld SFX_TYPE(ix), #sfx_type_invalid
      ;; }
   ;; }

   ;; Rescato el registro "BC" que habia metido en la pila anteriormente
   pop bc
   ;; Actualizo NEXT_FREE_SFX
   ld (next_free_sfx), bc

   ld a, (num_sfx)
   dec a
   ld (num_sfx), a

   ret
;; ===================================================== ;;

man_sfx_set4destruction::
   ld a, (ix)
   or #sfx_type_dead
   ld SFX_TYPE(ix), a
   ret


man_sfx_update::
   ld ix, #memoria_sfx
   sfx_valida_bucle_2:
   ld a, SFX_TYPE(ix)
   or #0
   jr z, if_sfx_invalida_2
   ;; IF @( ENTITY_TYPE != INVALID )
   ;; {
      and #sfx_type_dead
      jr z, if_sfx_invalida_3
      ;; IF @( ENTITY_TYPE == DEAD )
      ;; {
         call man_sfx_destroy
         jr if_sfx_invalida_4
      ;; }
      ;; ELSE @( ENTITY_TYPE != DEAD )
      ;; {
      if_sfx_invalida_3:
         ld de, #sfx_size
         add ix, de
         if_sfx_invalida_4:
         jr sfx_valida_bucle_2
      ;; }
   ;; }

   if_sfx_invalida_2:
   ret
