.include "cpctelera.h.s"
.include "man/manager_entity.h.s"
.include "man/level.h.s"
.include "sys_physics.h.s"
.include "includes.s"
.include "render.h.s"

;; ================== CAMARA SIGUE AL JUGADOR ================= ;
;; MAS DETALLES
;;  Hace calculos para colocar la camara en su sitio
;; ENTRADA
;;  IX = Posicion en memoria de la entidad
;; ============================================================ ;
sys_camera_update_one_entity:
    ld a, (man_level_map_camera + cam_x)
    ld b, a
    ld a, (man_level_map_camera + cam_y)
    ld c, a

    ld a, e_x(ix)
    sub b
    ld e_sx(ix), a

    ld a, e_y(ix)
    sub c
    ld e_sy(ix), a
    ret

;; ============================================================ ;



sys_camera_update::
    ld a, (man_level_tilemap_has_change)
    or a
    jr z, actualizar_camara
        xor a
        ld (man_level_tilemap_has_change), a
        ret

    actualizar_camara:
    call sys_camera_update_camera
    ld hl, #sys_camera_update_one_entity
    ld b, #COMP_RENDER
    call entity_man_forall_matching
    ret

;; ============================================================ ;



sys_camera_update_camera::
    ;; Hacer scroll cuando el estado lo pida
    ld a, (man_level_map_camera + cam_state)
    bit 7, a
    jr nz, scroll_left
    or a
    jr nz, scroll_right
    
    ;; He detectado que tiene que empezar un scroll
    ld a, (man_level_map_camera + cam_follow_x)
    cp #48
    jr nc, start_scroll_right
    cp #16
    jr c, start_scroll_left

    ret


start_scroll_left:
    ld a, (man_level_map_camera + cam_x)
    cp #X_MIN
    ret z

    ld a, #-8
    ld (man_level_map_camera + cam_state), a
    ret

start_scroll_right:
    ld a, (man_level_map_camera + cam_x)
    add a, #80
    cp #X_MAX
    ret z

    ld a, #8
    ld (man_level_map_camera + cam_state), a
    ret

scroll_left:
    ld hl, #(man_level_map_camera + cam_state)
    inc (hl)

    ld hl, (man_level_map_camera)
    dec hl
    ld (man_level_map_camera), hl

    ld a, (man_level_map_camera + cam_x)
    add #-4
    ld (man_level_map_camera + cam_x), a
    ret


scroll_right:
    ld hl, #(man_level_map_camera + cam_state)
    dec (hl)

    ld hl, (man_level_map_camera)
    inc hl
    ld (man_level_map_camera), hl

    ld a, (man_level_map_camera + cam_x)
    add #4
    ld (man_level_map_camera + cam_x), a
    ret