.include "man/entity_colision.h.s"
.include "colision.h.s"
.include "man/manager_entity.h.s"
.include "cpctelera.h.s"
.include "man/manager_entity.h.s"
.include "man/animation.h.s"
.include "animations.h.s"
.include "render.h.s"
.include "man/game_manager.h.s"
.include "man/level.h.s"
.include "man/sfx.h.s"



sys_colision_init::
    call man_entity_colision_getArray
    ld  (array_punt),hl
    ret


colision_update::

array_punt = . +1
    ld  hl, #0x000          ;; hl apunta al array de las entidades de colision

loop:                          ;;guardo la direccion del jugador en DE
    ld  e,(hl)
    inc hl
    ld d,(hl)
    inc hl


    ld__ixl_e
    ld__ixh_d

next_y:                        ;;guardo la direccion de las entidades que colisionan con el jugador

    ld  e,(hl)
    inc hl
    ld d,(hl)
    inc hl

    ld ix, #entities
    ld a, e_vidas(ix)
    or a
    jr  z, exit         ;; Si las vidas son 0, no mas colisiones


    ld a,e
    or d
    jr  z, exit                 ;;si la direccion que toque comparar con el jugador es nula (0000) termina

    ld__iyl_e                   
    ld__iyh_d
    push hl
    call comprobar_collisiones
    pop hl
    jr next_y
exit:
    ret



comprobar_collisiones::
    ld c,#0
    ld a, e_type(iy)
    or a
    jr z, __no_colision
    
    ld a, e_type(iy)
    and #TYPE_TUMBA
    jr nz, __no_colision

    ld a, e_type(iy)
    and #TYPE_BALA
    jr z, no_bala
    ld c, #3
no_bala:    
    ld a, e_attacking(ix)
    or #0
    jr nz, no_ataca
    ld  a,  e_x(ix)
    add e_w(ix)
    sub #8
    sub e_x(iy)
    jr  c, __no_colision
    jr normal_col

no_ataca:
    ;; if (e_x(ix) + e_w(ix) - e_x(iy) < 0) __no_colision
    ld  a,  e_x(ix)
    add e_w(ix)
    sub #2
    sub e_x(iy)
    jr  c, __no_colision
normal_col:

    ;; if (e_x(iy) + e_w(iy) - e_X(ix) < 0) __no_colision
    ld  a,  e_x(iy)
    add e_w(iy)
    sub c
    sub e_x(ix)
    jr  c, __no_colision

    ;; if (e_y(ix) + e_h(ix) - e_y(iy) < 0) __no_colision
    ld  a,  e_y(ix)
    add e_h(ix)
    sub e_y(iy)
    jr  c, __no_colision

    ;; if (e_y(iy) + e_h(iy) - e_y(ix) < 0) __no_colision
    ld  a,  e_y(iy)
    add e_h(iy)
    sub e_y(ix)
    jr  c, __no_colision

    ;ld  a,  #0xFF
    ;ld  (0xC000),   a
    ;;ret

    ;push ix
    ;push iy
    ;ld a, e_type(iy)
    ;and #TYPE_PUERTA
    ;sub #TYPE_PUERTA
    ;jr z, cambiar_nivel
    ;pop iy
    ;pop ix

    ld a, e_type(iy)
    and #TYPE_BALA
    jr nz, recibe_damage

    ld a, e_attacking(ix)
    or #0
    jr nz, golpea
    
    ld a, e_cooldown_vida(ix)
    or #0
    jr z, recibe_damage
    
    ret
decrementa_tick:
    
    dec a
    ld  e_cooldown_vida(ix), a
    ret
   
   __no_colision:
    ;ld  a,  #0xF0
    ;ld  (0xC000),   a
   ;; ld a,#0
   ;; ld (prueba), a

    ret

recibe_damage:
    ld a, c
    sub #3
    jr nz, no_bala_2
    ld e_type(iy), #TYPE_TUMBA




no_bala_2:

    ld a, e_type(iy)
    and #TYPE_PUERTA
    jr nz, puerta
    ld a, e_type(iy)
    and #TYPE_COFRE
    jr nz, cofre
    ld a, #12
    ld  e_cooldown_vida(ix), a
    ld (color_fondo), a

    ld e_impulso(ix), #-7
    ld hl, #_man_animation_player_2
    call sys_animations_change
    
    ld a,e_x(iy)
    inc a   
    inc a 
    ld e_x(iy), a

    ;; SI TE GOLPEAN, COMPROBAR QUE TIPO DE CORAZON TE QUITAN
    ;; "A" = Vidas amarillas actuales
    ld a, (vidas_extra_actuales)
    cp #0
    jr z, quitar_vida_roja
    ;; IF @( VIDAS EXTRAS ACTUALES > 0 )
    ;; {
        dec a
        ld (vidas_extra_actuales), a
        ld hl, #_sfx_damage_extra_text
        jr endif_quitar_vida
    ;; }
    quitar_vida_roja:
    ;; ELSE
    ;; {
        ld a, e_vidas(ix)
        or a
        jp z, muerto
            dec a
            ld e_vidas(ix), a
            ld hl, #_sfx_damage_text
    ;; }
    
    endif_quitar_vida:
    call sys_render_UI_both
    ld b, e_sx(ix)
    ld c, #70
    call man_sfx_create

    ret
cofre:
    ld bc, #0x2000
    push iy
    call add_bc_to_score
    pop iy
    ld e_type(iy), #TYPE_TUMBA

    ;ld e_vidas(ix), #0
    ret

puerta:
    jp cambiar_nivel
    ret

golpea:
 ;ld  a,  #0x0F
 ;ld  (0xC050),   a
    ld a, e_type(iy)
    and #TYPE_PUERTA
    ret nz
    ld a, e_type(iy)
    and #TYPE_COFRE
    ret nz
    ld a, e_cooldown_vida(iy)
    or #0
    ret nz
    ld a, #ENEMY_DAMAGE_CDOWN
    ld e_cooldown_vida(iy), a
    ld a, e_vidas(iy)
    sub e_ataque(ix)
    ld e_vidas(iy),a
    ld e_cooldown_mov(iy), #0
    ld e_impulso(iy), #4

    ld a, e_attacking(ix)
    cp #1
    jr nz, golpea_con_combo
    ld hl, #_sfx_100_points
    ld b, e_sx(iy)
    ld a, #4
    add a, b
    ld b, a
    ld c, #92
    call man_sfx_create

    ld bc, #0x0100
    call add_bc_to_score
    jr end_golpea

    golpea_con_combo:
    cp #2
    jr nz, golpea_con_combo_2
    ld a, e_ataque(ix)
    dec a
    jr z, end_golpea

    ld hl, #_sfx_200_points
    ld b, e_sx(iy)
    ld a, #4
    add a, b
    ld b, a
    ld c, #92
    call man_sfx_create

    ld bc, #0x0100
    call add_bc_to_score


    end_golpea:
    push iy
    pop ix
    ld a, e_comp(ix)
    and #COMP_DISPARO
    jr nz, skeleton_was_hit
        ld hl, #_man_animation_zombie_2
        call sys_animations_change
        ret
    skeleton_was_hit:
        ld hl, #_man_animation_skeleton_2
        call sys_animations_change
    ret
    golpea_con_combo_2:
    ld a, e_ataque(ix)
    dec a
    jr z, end_golpea

    ld hl, #_sfx_400_points
    ld b, e_sx(iy)
    ld a, #4
    add a, b
    ld b, a
    ld c, #92
    call man_sfx_create

    ld bc, #0x0400
    call add_bc_to_score 
    jr end_golpea 


cambiar_nivel:
    call man_level_inc_num_tilemap
        ;;ld a, #0xFF
    ;;ld  e_x(iy), a
    ret

muerto:
    ld a, #0xFF
    ld e_cooldown_vida(ix), a
    ret