.include "cpctelera.h.s"
.include "includes.s"
.include "man/manager_entity.h.s"
.include "man/animation.h.s"
.include "animations.h.s"
.include "render.h.s"
.include "templates.h.s"
.include "man/game_manager.h.s"
.include "man/level.h.s"
.include "man/sfx.h.s"



;; ===================== INIT DE SYS INPUT ==================== ;
 sys_input_init::
    ret

;; ============================================================ ;



;; ================ LEER TECLADO Y ACTUALIZAR ================ ;
;; MAS DETALLES
;;  Lee el teclado y, dependiendo de la tecla pulsada, hace una accion
;; ENTRADA
;;  IX = Posicion del jugador
;; ============================================================ ;
 sys_input_update::
    ;; Guardo en IX la direccion de la 1º entidad => JUGADOR
    ld ix, #entities

    ;; Reseteo las velociades del jugador => NO HAY ACELERACION
    ld e_vx(ix), #0
    ld e_vy(ix), #0
    call cooldown_teclas
    ;; Leo el teclado
    call cpct_scanKeyboard_f_asm
    call cpct_isAnyKeyPressed_f_asm
    or #0
    ret z
    
    ld hl, #Joy0_Left
    call cpct_isKeyPressed_asm
    jr nz, O_isPressed

    ;; Compruebo teclas de movimiento
    ;; ======================================================= ;;
    ld hl, #Key_O                       ;; KEY "O" == MOVE LEFT
    call cpct_isKeyPressed_asm
    jr z, O_NotPressed
    ;; IF @( "O" IS PRESSED )
    ;; {
        O_isPressed:
        ld a, e_attacking(ix)
        or a
        jr nz, O_NotPressed
        ;; IF @( PLAYER IS NOT ATTACKING )
        ;; {
            ld e_vx(ix), #-1
        ;; }
    ;; }
    O_NotPressed:
    ;; ======================================================= ;;
    


    ld hl, #Joy0_Right
    call cpct_isKeyPressed_asm
    jr nz, P_isPressed


    ;; ======================================================= ;;
    ld hl, #Key_P                       ;; KEY "P" == MOVE RIGHT
    call cpct_isKeyPressed_asm
    jr z, P_NotPressed
    ;; IF @( "P" IS PRESSED )
    ;; {
        P_isPressed:
        ld a, e_attacking(ix)
        or a
        jr nz, P_NotPressed
        ;; IF @( PLAYER IS NOT ATTACKING )
        ;; {
            ld e_vx(ix), #1
        ;; }
    ;; }
    P_NotPressed:
    ;; ======================================================= ;;


    ;; ======================================================= ;;
    ld hl, #Key_V                       ;; KEY "P" == MOVE RIGHT
    call cpct_isKeyPressed_asm
    jr z, V_NotPressed
    ;; IF @( "P" IS PRESSED )
    ;; {
        ld bc, #0x0900
        call add_bc_to_score
    ;; }
    V_NotPressed:
    ;; ======================================================= ;;



    ld hl, #Joy0_Up
    call cpct_isKeyPressed_asm
    jr nz, Q_isPressed


    ;; ======================================================= ;;
    ld hl, #Key_Q                 ;; KEY "Q" == JUMP
        call cpct_isKeyPressed_asm
        jr z, Q_NotPressed
        ;; IF @( "Q" IS PRESSED )
        ;; {
            Q_isPressed:
            ld  a, (hero_jump)
            cp  #-1
            jr  nz, Q_NotPressed

            ;;El salto no esta activado, lo activo
            ld  a,  #0
            ld  (hero_jump),  a
            ld hl, #_man_animation_player_J
            call sys_animations_change
            ;; }
        ;; }
        Q_NotPressed:
    ;; ======================================================= ;;




    ;; ======================================================================= ;;
    ;; A PARTIR DE AQUI SON ACCIONES QUE *NO* SE PUEDEN HACER MIENTRAS SALTAS  ;;
    ;; ======================================================================= ;;
    ld	a, (hero_jump)
    cp #-1
    ret nz
    ;; ======================================================================= ;;
    ;; A PARTIR DE AQUI SON ACCIONES QUE *NO* SE PUEDEN HACER MIENTRAS SALTAS  ;;
    ;; ======================================================================= ;;



    ld hl, #Joy0_Fire1
    call cpct_isKeyPressed_asm
    jr nz, Space_isPressed


    ;; ======================================================= ;;
    ld hl, #Key_Space                   ;; KEY "SPACE" == ATTACK
        call cpct_isKeyPressed_asm
        jr z, Space_NotPressed2

        Space_isPressed:
        ld a, e_cooldown_ataque(ix)
        or #0
        jr nz, Space_NotPressed2
        ;; IF @( "SPACE" IS PRESSED )
        ;; {
            ;; Reinicio el cooldown del espacio
            ld e_cooldown_ataque(ix), #PLAYER_ATAQUE_CDOWN
            ;; Guardo en "A" si el personaje se encontraba atacando
            ld a, e_attacking(ix)
            or a
            jr nz, Posible_combo
            ;; IF @( PLAYER IS NOT ATTACKING -> ATTACK )
            ;; {
                ld e_impulso(ix), #4
                ;; Ahora su estado si esta atacando
                ld e_attacking(ix), #1
                ld e_ataque(ix), #1
                ;; Y le cambio su animacion a atacar
                ld hl, #_man_animation_player_1
                call sys_animations_change

            ;; }
        ;; }
    ;; ======================================================= ;;

    Space_NotPressed2:
        jr Space_NotPressed

    ;; ======================================================= ;;
    ;; Antes de comprobar el ataque, miro el sprite_combo
    Posible_combo:
    ld a, e_sprite_l(ix)
    ld hl, #sprite_combo
    sub (hl)
    jr nz, Space_NotPressed
        ld a, e_sprite_h(ix)
        inc hl
        sub (hl)
        jr nz, mal_combo     ;; KEY "SPACE" == ATTACK
        ;; IF @( SPRITE_ACTUAL == SPRITE_COMBO )
        ;; {
            ld a, e_attacking(ix)
            cp #1
            jr nz, segundo_combo
            ;; ============ PRIMER COMBO ============ ;
            ;; IF @( IS_ATTACKING == 1 -> PRIMER COMBO )
            ;; {
                ld hl, #_man_animation_player_3
                call sys_animations_change
                ld e_impulso(ix), #4
                ld e_ataque(ix), #2
                ld e_attacking(ix), #2
                ld hl, #_SP_Player3_3
                ld (sprite_combo), hl
                jr endif_combos
            ;; }


            ;; ============ SEGUNDO COMBO ============ ;
            segundo_combo:
            ; IF @( IS_ATTACKING == 2 -> SEGUNDO COMBO )
            ;; {
                ld hl, #_man_animation_player_4
                call sys_animations_change
                ld e_impulso(ix), #6
                ld e_ataque(ix), #3
                ld e_attacking(ix), #3
            ;; }
            
            endif_combos:
            call sys_render_UI_both
            jr Space_NotPressed
        ;; }
    
    
    
    mal_combo:
        ld a, e_impulso(ix)
        bit 7, a
        jr nz, Space_NotPressed
            ld hl, #_sfx_miss_text
            ld b, e_sx(ix)
            ld c, #70
            call man_sfx_create
            ld e_impulso(ix), #-6
            ld hl, #_man_animation_player_2
            call sys_animations_change

    Space_NotPressed:
       

    ;; ======================================================= ;;

    ret
 ;; ============================================================ ;
cooldown_teclas:
    ld a, e_cooldown_ataque(ix)
    or #0
    ret z
    ld a, e_cooldown_ataque(ix)
    dec a
    ld e_cooldown_ataque(ix), a
    ret