.include "sys_physics.h.s"
.include "cpctelera.h.s"
.include "man/manager_entity.h.s"
.include "man/game_manager.h.s"
.include "man/level.h.s"
.include "render.h.s"
.include "camera.h.s"
.include "templates.h.s"
.include "man/animation.h.s"
.include "animations.h.s"


sys_physics_init::
    ld a, #0xFF
    ld (hero_jump), a
    ret

;;
;; Update de las entidades
sys_physics_update::
    ld hl, #sys_physics_one_entity
    ld b, #COMP_PHYSIC
    call entity_man_forall_matching
    ret 
;;
;;
;;;;IX Direccion de memoria de entidad a actualizar
;;
sys_physics_one_entity: 
    ld a, e_type(ix)
    and #TYPE_PLAYER
    jr z, no_player
    ;; Actualizo las coordenadas de la entidad a la que sigo

        ld a, (man_level_tilemap_has_change)
        or a
        jr z, actualizar_fisica
            ret

        actualizar_fisica:
        ld a, e_sx(ix)
        ld (man_level_map_camera + cam_follow_x), a
        ld a, e_sy(ix)
        ld (man_level_map_camera + cam_follow_y), a
        ld a, e_impulso(ix)
    
        bit 7, a
        jr z, otro_impulso
        inc a
        ld e_impulso(ix), a
        ld e_vx(ix), #-1
        ld e_cooldown_mov(ix), #0
        jr no_hay_impulso

        otro_impulso:
        or a
        jr z, no_hay_impulso
        sub #1
        ld e_impulso(ix), a
        ld e_vx(ix), #1
        ld e_cooldown_mov(ix), #0
    ;;;

    no_hay_impulso:
        ld  a, (hero_jump)
        cp  #-1
        jp  nz,jumpControl

    ;; Actualizamos las posiciones en funcion de las velocidades
    ;; Actualizamos X
no_player:
    
;;    ld a, e_cooldown_mov(ix)
;;    or #0
;;    jr z, actualiza_variable
;;    


actualiza_variable::
    ld a, e_type(ix)
    and #TYPE_BALA
    jp nz, bala
player:
    ld a, e_cooldown_mov(ix)
    or #0
    jr nz, decrementa_tick
    ld a, e_type(ix)
    and #TYPE_PLAYER
    jr z, no_player2

    ld a, #X_MAX+1
    sub e_w(ix)
    ld c, a
    ld a, e_x(ix)
    add e_vx(ix)                            
    cp c
    jr nc, end_pos_x
    valid_x:
        ld e_x(ix), a
        ld e_sx(ix), a
    end_pos_x:
    
    ;; Actualizamos Y
    ld a, #Y_MAX+1
    sub e_h(ix)
    ld c,a
    ld a, e_y(ix)                              
    add e_vy(ix)
    cp c
    jr nc, end_pos_y
    valid_y:
        ld e_y(ix), a
        ld e_sy(ix), a   
    end_pos_y:

   
    ret
    decrementa_tick:
    dec a
    ld  e_cooldown_mov(ix), a
    ret
 no_player2:
        ld a, e_impulso(ix)
    
        bit 7, a
        jr z, otro_impulso2
        inc a
        ld e_impulso(ix), a
        ld e_vx(ix), #-1
        ld e_cooldown_mov(ix), #0
        jr no_hay_impulso2

        otro_impulso2:
        or a
        jr z, no_hay_impulso2
        sub #1
        ld e_impulso(ix), a
        ld e_vx(ix), #1
        ld e_cooldown_mov(ix), #0
        no_hay_impulso2:
        ld hl, #enemy_move_cdown
        ld a, (hl)
        ld  e_cooldown_mov(ix), a

        ld a, e_ia_x(ix)
        add e_w(ix)
        sub #6
        ld b, a

        ld a, e_x(ix)
        add e_vx(ix)                            
        cp b
        jr c, end_pos_x2
        valid_x2:

            ld e_x(ix), a
            ld e_sx(ix), a

        end_pos_x2:
        ret
bala:
    ld a, e_x(ix)
    add e_vx(ix)                            
    ld e_x(ix), a
    ld e_sx(ix), a
    ld a, e_sx(ix)
    or #0
    ret nz
    ld e_type(ix), #TYPE_TUMBA
    ret

;;    
;;
jumpControl:
  
    ;; get jump value
    ld	hl, #jumptable
    ld	a, (hero_jump)
    ld	c, a
    ld	b, #0
    add	hl, bc

    ;; check end of jumping
    ld 	a, (hl)
    cp	#0x80
    jr	z, end_of_jump

    ;;do jump movement
    ld e_vy(ix), a


    ;;increment Hero_jump Index
    ld	a, (hero_jump)
    inc	a
    ld 	(hero_jump), a

    jp actualiza_variable

    ;;put -1 in the jump
end_of_jump:
    ld 	a, #-1
    ld	(hero_jump), a
    ld hl, #_man_animation_player_0
    call sys_animations_change

    jp actualiza_variable