.include "man/manager_entity.h.s"
.include "templates.h.s"
.include "includes.s"
.include "man/animation.h.s"

entity_player_temp::
    .db TYPE_PLAYER
    .db COMP_DEFAULT | COMP_INPUT | COMP_RENDER | COMP_COLISION | COMP_PHYSIC  ;; Componente
    .db 20                                                                     ;; Posicion en x (GLOBAL)
    .db 82                                                                     ;; Posicion en y (GLOBAL)
    .db 16                                                                     ;; Ancho del sprite
    .db 32                                                                     ;; Alto del sprte
    .dw _SP_Player0_0                                                          ;; Sprite
    .dw _man_animation_player_0                                                ;; Animacion
    .db 0x05                                                                   ;; Contador de animacion
    .db 0                                                                      ;; Velocidad en x
    .db 0                                                                      ;; Velocidad en y
    .db 0                                                                      ;; Esta atacando o no
    .db 20                                                                     ;; Posicion en x (SCREEN)
    .db 82                                                                     ;; Posicion en y (SCREEN)
    .db 5                                                                      ;; Vidas
    .db 0                                                                      ;; Impulso
    .db 0                                                                      ;; Direccion hacia donde va la IA
    .db 0                                                                      ;; Estado de la IA
    .db 0                                                                      ;; Cooldown de movimiento
    .db 0                                                                    ;; Cooldown de recibir danyo  
    .db 0                                                                      ;; Cooldown de ataque                                           
    .db 1                                                                      ;; Danyo de ataque


jumptable::
	.db #-5, #-4,#-4, #-3, #-3, #-2, #-1, #-1
	.db #-1, #00, #00
	.db #01, #02, #02, #03, #03, #04, #04, #05
	.db #0x80
hero_jump::
    .db #-1



entity_player_temp2::
    .db TYPE_ENEMY
    .db  COMP_DEFAULT | COMP_RENDER | COMP_COLISION | COMP_IA | COMP_PHYSIC      ;; Componente
    .db 120                                                                     ;; Posicion en x (GLOBAL)
    .db 83                                                                     ;; Posicion en y (GLOBAL)
    .db 11                                                                     ;; Ancho del sprite
    .db 31                                                                     ;; Alto del sprte
    .dw _Zombie1_0                                                             ;; Sprite
    .dw _man_animation_zombie_1                                                ;; Animacion
    .db 0x02                                                                   ;; Contador de animacion
    .db 0                                                                      ;; Velocidad en x
    .db 0                                                                      ;; Velocidad en y
    .db 0                                                                      ;; Esta atacando o no
    .db 120                                                                     ;; Posicion en x (SCREEN)
    .db 83                                                                     ;; Posicion en y (SCREEN)
    .db 2                                                                      ;; Vidas
    .db 0                                                                      ;; Impulso
    .db 0                                                                      ;; Direccion hacia donde va la IA
    .db ia_estado_stand_by                                                     ;; Estado de la IA
    .db 3                                                                      ;; Cooldown de movimiento
    .db 0x1D                                                                     ;; Cooldown de recibir danyo  
    .db 0                                                                      ;; Cooldown de ataque                                           
    .db 0                                                                      ;; Danyo de ataque  
    
entity_esqueleto::
    .db TYPE_ENEMY
    .db  COMP_DEFAULT | COMP_RENDER | COMP_COLISION | COMP_IA | COMP_DISPARO    ;; Componente
    .db 120                                                                     ;; Posicion en x (GLOBAL)
    .db 92                                                                     ;; Posicion en y (GLOBAL)
    .db 11                                                                     ;; Ancho del sprite
    .db 23                                                                     ;; Alto del sprte
    .dw _SP_Esqueleto0_0                                                            ;; Sprite
    .dw _man_animation_skeleton_0                                              ;; Animacion
    .db 0x04                                                                 ;; Contador de animacion
    .db 0                                                                      ;; Velocidad en x
    .db 0                                                                      ;; Velocidad en y
    .db 0                                                                      ;; Esta atacando o no
    .db 120                                                                     ;; Posicion en x (SCREEN)
    .db 92                                                                     ;; Posicion en y (SCREEN)
    .db 2                                                                      ;; Vidas
    .db 0                                                                      ;; Impulso
    .db 0                                                                      ;; Direccion hacia donde va la IA
    .db ia_estado_stand_by                                                     ;; Estado de la IA
    .db 3                                                                      ;; Cooldown de movimiento
    .db 0x1D                                                                     ;; Cooldown de recibir danyo  
    .db 0                                                                      ;; Cooldown de ataque                                           
    .db 0                                                                      ;; Danyo de ataque  
    




entity_bala_temp::
    .db TYPE_BALA
    .db  COMP_DEFAULT | COMP_RENDER | COMP_PHYSIC | COMP_COLISION                            ;; Componente
    .db 0                                                                      ;; Posicion en x (GLOBAL)
    .db 0                                                                      ;; Posicion en y (GLOBAL)
    .db 6                                                                     ;; Ancho del sprite
    .db 7                                                                     ;; Alto del sprte
    .dw _SP_Hueso                                                            ;; Sprite
    .dw 00                                                ;; Animacion
    .db 0                                                                      ;; Contador de animacion
    .db -1                                                                      ;; Velocidad en x
    .db 0                                                                      ;; Velocidad en y
    .db 0                                                                      ;; Esta atacando o no
    .db 0                                                                      ;; Posicion en x (SCREEN)
    .db 0                                                                      ;; Posicion en y (SCREEN)
    .db 5                                                                      ;; Vidas
    .db 0                                                                      ;; Impulso
    .db 0                                                                      ;; Direccion hacia donde va la IA
    .db 0                                                                      ;; Estado de la IA
    .db 0                                                                      ;; Cooldown de movimiento
    .db 0xDE                                                                     ;; Cooldown de recibir danyo  
    .db 0                                                                      ;; Cooldown de ataque                                           
    .db 0xAA                                                                      ;; Danyo de ataque



entity_door::
    .db TYPE_PUERTA
    .db COMP_DEFAULT | COMP_RENDER | COMP_COLISION  ;; Componente
    .db 225                                                                     ;; Posicion en x (GLOBAL)
    .db 85                                                                     ;; Posicion en y (GLOBAL)
    .db 1                                                                     ;; Ancho del sprite
    .db 1                                                                     ;; Alto del sprte
    .dw _SP_PuertaNextLvl                                                          ;; Sprite
    .dw _man_animation_player_0                                                ;; Animacion
    .db 0                                                                   ;; Contador de animacion
    .db 0                                                                      ;; Velocidad en x
    .db 0                                                                      ;; Velocidad en y
    .db 0                                                                      ;; Esta atacando o no
    .db 225                                                                     ;; Posicion en x (SCREEN)
    .db 85                                                                     ;; Posicion en y (SCREEN)
    .db 255                                                                      ;; Vidas
    .db 0                                                                      ;; Impulso
    .db 0                                                                      ;; Direccion hacia donde va la IA
    .db 0                                                                      ;; Estado de la IA
    .db 0                                                                      ;; Cooldown de movimiento
    .db 0                                                                    ;; Cooldown de recibir danyo  
    .db 0                                                                      ;; Cooldown de ataque                                           
    .db 0                                                                      ;; Danyo de ataque




entity_cofre::
    .db TYPE_COFRE
    .db COMP_DEFAULT | COMP_RENDER | COMP_COLISION  ;; Componente
    .db 190                                                                     ;; Posicion en x (GLOBAL)
    .db 94                                                                     ;; Posicion en y (GLOBAL)
    .db 11                                                                     ;; Ancho del sprite
    .db 19                                                                     ;; Alto del sprte
    .dw _SP_Cofre                                                              ;; Sprite
    .dw 0                                                                      ;; Animacion
    .db 0                                                                      ;; Contador de animacion
    .db 0                                                                      ;; Velocidad en x
    .db 0                                                                      ;; Velocidad en y
    .db 0                                                                      ;; Esta atacando o no
    .db 190                                                                     ;; Posicion en x (SCREEN)
    .db 94                                                                     ;; Posicion en y (SCREEN)
    .db 0                                                                      ;; Vidas
    .db 0                                                                      ;; Impulso
    .db 0                                                                      ;; Direccion hacia donde va la IA
    .db 0                                                                      ;; Estado de la IA
    .db 0                                                                      ;; Cooldown de movimiento
    .db 0                                                                      ;; Cooldown de recibir danyo  
    .db 0                                                                      ;; Cooldown de ataque                                           
    .db 0xEE                                                                   ;; Danyo de ataque

enemy_move_cdown::
    .db ENEMY_MOVE_CDOWN
enemy_ataque_cdown::
    .db ENEMY_ATAQUE_CDOWN
cont::
    .db 0
